Update documentation and config file
[grml-debootstrap.git] / grml-debootstrap
old mode 100644 (file)
new mode 100755 (executable)
index 72098fb..2a36d4e
@@ -4,13 +4,13 @@
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Don Apr 12 11:55:21 CEST 2007 [mika]
+# Latest change: Die Jun 05 13:51:21 CEST 2007 [mika]
 ################################################################################
 # http://www.debian.org/releases/stable/i386/index.html.en
 
 set -e # exit on any error
 
-VERSION='0.6'
+VERSION='0.10'
 
 # source core functions {{{
 . /etc/grml/lsb-functions
@@ -22,23 +22,6 @@ check4progs debootstrap || exit 1
 check4root || exit 1
 # }}}
 
-# cmdline handling {{{
-case $* in
-   -h*|--h*)
-     einfo "$0 - wrapper around debootstrap for installing plain Debian via grml"
-     einfo "Adjust /etc/debootstrap/config and invoke $0 afterwards."
-     eend 0
-     exit 0
-   ;;
-   -v|--v*)
-     einfo "$0 version $VERSION"
-     einfo "Send bug reports to Michael Prokop <mika@grml.org>."
-     eend 0
-     exit 0
-   ;;
-esac
-# }}}
-
 # without config file it won't work {{{
 if [ -r /etc/debootstrap/config ] ; then
    . /etc/debootstrap/config
@@ -48,6 +31,89 @@ else
 fi
 # }}}
 
+# cmdline handling {{{
+usage() {
+  einfo "$0 - version $VERSION"
+  echo  "   A wrapper around debootstrap for installing plain Debian via grml"
+  echo
+  einfo "Usage: $0 [options]"
+  echo  "   Adjust /etc/debootstrap/config and invoke $0 afterwards or use the cmdline option:"
+  echo
+  einfo "Valid options:"
+  echo  "
+    -h|--help                   Print this usage information and exit.
+    -v|--version                Show summary of options and exit.
+
+    -t|--target <target>        Target partition (/dev/...) or directory.
+    -r|--release <release>      Specify release of new Debian system. Supported relases: sarge, etch, lenny and sid.
+    -m|--mirror <URL>           Specify mirror which should be used for apt-get/aptitude.
+    -i|--iso <mnt>              Specify mountpoint where Debian ISO is mounted to (instead of using mirror)
+    -p|--mntpoint <mnt>         Specify mountpoint that should be used for mounting the target system.
+    --groot <device>            Specify root device for usage in grub (corresponds with \$TARGET).
+    --grub <device>             Where do you want to install grub to? Use grub syntax for specifying.
+    --password <pwd>            Use specified password as password for user root. Use with caution.
+    --boot_append <appendline>  Add specified appendline to kernel whilst booting
+
+"
+}
+
+while [ "$#" -gt "0" ] ; do
+    case $1 in
+        -v|--version)
+            einfo "$0 - version $VERSION"
+            einfo "Send bug reports to Michael Prokop <mika@grml.org>."
+            eend 0
+            exit 0
+            ;;
+        -t|--target)
+            shift
+            TARGET=$1
+            ;;
+        --grub)
+            shift
+            GRUB=$1
+            ;;
+        --groot)
+            shift
+            GROOT=$1
+            ;;
+        --release)
+            shift
+            RELEASE=$1
+            ;;
+        -p|--mntpoint)
+            shift
+            MNTPOINT=$1
+            ;;
+        --password)
+            shift
+            ROOTPASSWORD=$1
+            ;;
+        -m|--mirror)
+            shift
+            MIRROR=$1
+            CHROOTMIRROR=$1
+            ;;
+        -i|--iso)
+            shift
+           [ -n "$MIRROR" ] && unset MIRROR
+            ISO=$1
+            ;;
+        -h|--help)
+            usage ; eend 0
+            eend 0
+            exit 0
+            ;;
+        *)
+            eerror "Syntax error."
+            usage ; eend 1
+            exit 1
+            ;;
+    esac
+    shift
+done
+# }}}
+
 # set/check variables {{{
 
 # inside the chroot system the locales might not be available, so use minimum:
@@ -94,10 +160,28 @@ else
    ARCHINFO=" (${ARCH})"
 fi
 
+# make sure we have the right syntax when using an iso image
+case $ISO in
+   file*) # do nothing
+    ;;
+   *)
+    ISO=file:$1
+    ;;
+esac
+ISODIR=${ISO##file:}
+
 # provide variables to chroot system
-echo "
-ARCH=$ARCH
-" > /etc/debootstrap/variables
+touch /etc/debootstrap/variables
+chmod 600 /etc/debootstrap/variables # make sure nobody except root can read it
+[ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  /etc/debootstrap/variables
+[ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> /etc/debootstrap/variables
+[ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> /etc/debootstrap/variables
+[ -n "$TARGET" ] && echo "TARGET=$TARGET" >> /etc/debootstrap/variables
+[ -n "$ISO" ]    && echo "ISO=$ISO"       >> /etc/debootstrap/variables
+[ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> /etc/debootstrap/variables
+[ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
+[ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> /etc/debootstrap/variables
+[ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> /etc/debootstrap/variables
 
 # make sure at least $TARGET is set [the partition for the new system]
 if [ -z "$TARGET" ] ; then
@@ -110,48 +194,72 @@ fi
 # we want to exit smoothly and clean:
 bailout(){
   # make sure $TARGET is not mounted when exiting grml-debootstrap
-  if [ -n "$TARGET" ] ; then
-     if grep -q $TARGET /proc/mounts ; then
+  if [ -n "$MNTPOINT" ] ; then
+     if grep -q $MNTPOINT /proc/mounts ; then
         # make sure nothing is left inside chroot so we can unmount it
-        [ -x "$TARGET"/etc/init.d/ssh   ] && "$TARGET"/etc/init.d/ssh stop
-        [ -x "$TARGET"/etc/init.d/mdadm ] && "$TARGET"/etc/init.d/mdadm stop
-        chroot "$TARGET" umount /sys  1>/dev/null 2>&1
-        chroot "$TARGET" umount /proc 1>/dev/null 2>&1
-        echo "Unmounting $TARGET"
-        umount "$TARGET"
+        [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
+        [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
+        # ugly, but make sure we really don't leav anything
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
+        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
+        einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
      fi
   fi
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
+  [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
   exit "$EXIT"
 }
 trap bailout 1 2 3 15
 
 # we want to execute all the functions only once, simple check for it:
 stage() {
-  if grep -q done "$STAGES/$1" 2>/dev/null ; then
-     ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
-     return 1
-  else
+  if [ -n "$2" ] ; then
      echo "$2" > "$STAGES/$1"
      return 0
+  elif grep -q done "$STAGES/$1" 2>/dev/null ; then
+     ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
+     return 1
   fi
 }
 # }}}
 
 # user should recheck his configuration {{{
-einfo "$0 - Please recheck configuration before execution:"
-echo "
-   Target:           $TARGET"
-   case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
-   [ -n "$GRUB" ] && echo "   Install grub to:  $GROOT / $GRUB"
-   case "$MNTPOINT" in "$TARGET") ;; *) echo "  Important! Continuing will delete all data from ${TARGET}!" ;; esac
-   echo
-einfon "Is this ok for you? [y/N] "
+# support full automatic installation:
+checkforrun() {
+   dialog --timeout 10 --title "$0" \
+          --yesno "Do you want to stop at this stage?
 
-read a
-if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
-   eerror "Exiting as requested." ; eend 1
-   exit 1
+Notice: you are running grml-debootstrap in non-interactive mode.
+grml-debootstrap will install Debian ${RELEASE} on ${TARGET}.
+Last chance to quit. Timeout of 10 seconds running....
+
+Do you want to stop now?" 0 0 2>/dev/null
+}
+
+if [ -n "$AUTOINSTALL" ] ; then
+   if checkforrun ; then
+      eerror "Exiting as requested" ; eend 0
+      exit 1
+   fi
+else # if not running automatic installation display configuration and prompt for execution:
+   einfo "$0 - Please recheck configuration before execution:"
+   echo
+   echo "   Target:           $TARGET"
+      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
+      [ -n "$GRUB" ]   && echo "   Install grub to:  $GROOT / $GRUB"
+      [ -n "$MIRROR" ] && echo "   Using mirror:     $MIRROR"
+      [ -n "$ISO" ] && echo "   Using iso:        $ISO"
+      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
+      echo
+   einfon "Is this ok for you? [y/N] "
+   read a
+   if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
+      eerror "Exiting as requested." ; eend 1
+      exit 1
+   fi
 fi
 # }}}
 
@@ -190,14 +298,29 @@ mount_target() {
        eend $?
      fi
   fi
+  if [ -n "$ISODIR" ] ; then
+     einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
+     mkdir -p "$MNTPOINT/$ISODIR"
+     mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
+     eend $?
+  fi
 }
 # }}}
 
 # install main chroot {{{
 debootstrap_system() {
-  einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using mirror $MIRROR"
-  $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR
-  eend $?
+  if ! grep -q $MNTPOINT /proc/mounts ; then
+          mount_target
+  fi
+  if grep -q $MNTPOINT /proc/mounts ; then
+     einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
+     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
+     $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
+     eend $?
+  else
+     eerror "Error: $MNTPOINT not mounted, can not continue."
+     eend 1
+  fi
 }
 # }}}
 
@@ -209,9 +332,11 @@ preparechroot() {
   mkdir $MNTPOINT/etc/debootstrap/
 
   # make sure we have our files for later use via chroot-script
-  cp /etc/debootstrap/config    $MNTPOINT/etc/debootstrap/
-  cp /etc/debootstrap/packages  $MNTPOINT/etc/debootstrap/packages
-  cp /etc/debootstrap/variables $MNTPOINT/etc/debootstrap/variables
+  cp /etc/debootstrap/config          $MNTPOINT/etc/debootstrap/
+  cp /etc/debootstrap/packages        $MNTPOINT/etc/debootstrap/packages
+  cp /etc/debootstrap/variables       $MNTPOINT/etc/debootstrap/variables
+
+  cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
 
   # make sure we can access network [relevant for cdebootstrap]
   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
@@ -231,9 +356,17 @@ preparechroot() {
 
 # execute chroot-script {{{
 chrootscript() {
-  einfo "Executing chroot-script now"
-  chroot "$MNTPOINT" /bin/chroot-script
-  eend $?
+  if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
+     mount_target
+  fi
+  if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
+     einfo "Executing chroot-script now"
+     chroot "$MNTPOINT" /bin/chroot-script
+     eend $?
+  else
+     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
+     eend 1
+  fi
 }
 # }}}
 
@@ -243,7 +376,8 @@ grub_install() {
      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
   else
      einfo "Installing grub on ${GRUB}:"
-     grub-install --root-directory="$MNTPOINT" "(${GRUB})"
+     [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
+     $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
      eend $?
   fi
 }
@@ -271,22 +405,25 @@ fscktool() {
 # }}}
 
 # now execute all the functions {{{
-  stage mkfs               && mkfs               && stage mkfs done               || bailout
-  stage tunefs             && tunefs             && stage tunefs done             || bailout
-  stage mount_target       && mount_target       && stage mount_target done       || bailout
-  stage debootstrap_system && debootstrap_system && stage debootstrap_system done || bailout
-  stage preparechroot      && preparechroot      && stage preparechroot done      || bailout
-  stage chrootscript       && chrootscript       && stage chrootscript done       || bailout
-  stage grub_install       && grub_install       && stage grub_install done       || bailout
-  stage umount_chroot      && umount_chroot      && stage umount_chroot done      || bailout
-  stage fscktool           && fscktool           && stage fscktool done           || bailout
+for i in mkfs tunefs mount_target debootstrap_system preparechroot \
+         chrootscript grub_install umount_chroot fscktool ; do
+    if stage $i ; then
+       $i && stage $i done || bailout 2 "i"
+    fi
+done
 # }}}
 
 # stages {{{
   echo done > $STAGES/grml-debootstrap
 # }}}
 
-  einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
+if [ -n "$AUTOINSTALL" ] ; then
+   dialog --title "$0" --msgbox \
+          "Finished execution of ${0}.
+Enjoy your Debian system." 6 60
+else
+   einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
+fi
 
 ## END OF FILE #################################################################
 # vim: ai tw=100 expandtab foldmethod=marker